package org.iwsec.pws.pwscup2016.ano;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

import org.iwsec.pws.pwscup2016.Utility;

public class Ya {
	static protected int compare(ArrayList<? extends String> r1, ArrayList<? extends String> r2, int i, Function<String, Integer> f) {
		return Integer.compare(f.apply(r1.get(i)), f.apply(r2.get(i)));
	}

	/**
	 * @return G|bN̓B
	 */
	static protected int parseDob(String value) {
		try {
			return (int) (new SimpleDateFormat("yyyy/M/d").parse(value).getTime() / (1000L * 60 * 60 * 24));
		}
		catch (ParseException e) {
			throw new IllegalArgumentException(value);
		}
	}

	static protected int parseCountry(String value) {
		// At@xbgł̃CfbNXԂB
		return Arrays.asList("Australia", "Austria", "Bahrain", "Belgium", "Brazil", "Canada", "Channel Islands", "Cyprus", "Czech Republic", "Denmark", "EIRE", "European Community", "Finland", "France", "Germany", "Greece", "Iceland", "Israel", "Italy", "Japan", "Lebanon", "Lithuania", "Malta", "Netherlands", "Norway", "Poland", "Portugal", "RSA", "Saudi Arabia", "Singapore", "Spain", "Sweden", "Switzerland", "USA", "United Arab Emirates", "United Kingdom").indexOf(value);
	}

	protected List<? extends Integer> newIndexList(List<? extends List<? extends String>> mTable) {
		// ܂CfbNXύXOMapAListB
		Map<? extends Integer, ? extends Integer> map = newMap(mTable);
		List<Integer> indexList = new ArrayList<>();
		for (int i = 0; i < mTable.size(); i++) {
			indexList.add(map.get(i));
		}
		return indexList;
	}

	protected Map<? extends Integer, ? extends Integer> newMap(List<? extends List<? extends String>> mTable) {
		// בւŃCfbNXAPׂɕϊ邱ƂMapɂĕԂB
		List<? extends Integer> indexList = newIndexListBySort(mTable);
		Map<Integer, Integer> map = new HashMap<>();
		Integer last = null;
		for (Integer index : indexList) {
			map.put(index, last);
			last = index;
		}
		map.put(indexList.get(0), last);
		return map;
	}

	protected List<? extends Integer> newIndexListBySort(List<? extends List<? extends String>> mTable) {
		// DOB, COUNTRY, GENDER ̗DxŃ\[gA\[g̍sCfbNXԂB
		ArrayList<ArrayList<String>> mCopy = Utility.copyTable(mTable);
		for (int i = 0; i < mCopy.size(); i++) {
			mCopy.get(i).add(String.valueOf(i));
		}
		Collections.sort(mCopy, (r1, r2) -> {
			int c = compare(r1, r2, Utility.INDEX_M_DOB, Ya::parseDob);
			if (c != 0) {
				return c;
			}
			c = compare(r1, r2, Utility.INDEX_M_COUNTRY, Ya::parseCountry);
			if (c != 0) {
				return c;
			}
			c = compare(r1, r2, Utility.INDEX_M_GENDER, s -> s.equals("f") ? 0 : 1);
			if (c != 0) {
				return c;
			}
			return 0;
		});
		return mCopy.stream().map(r -> Integer.parseInt(r.get(r.size() - 1))).collect(Collectors.toList());
	}

	static public void main(String... args) throws IOException {
		Path in = null;
		Path out = null;
		if (args.length > 0) {
			in = Paths.get(args[0]);
			if (args.length > 1) {
				out = Paths.get(args[1]);
			}
		}

		ArrayList<ArrayList<ArrayList<String>>> tableList = Utility.read(in);

		Ya one = new Ya();
		List<? extends Integer> indexList = one.newIndexList(tableList.get(0));
		tableList.add(Utility.asTable(indexList));

		Utility.write(out, tableList);
	}
}
