package org.iwsec.pws.pwscup2016.check;

import java.util.Objects;

/**
 * o͗pG[bZ[W̃f[^B
 * @author yamaoka.yuji@jp.fujitsu.com
 *
 */
public class Message {
	private int lineNumber;
	private String message;

	public Message(int lineNumber, String message) {
		this.lineNumber = lineNumber;
		this.message = Objects.requireNonNull(message);

		if (lineNumber <= 0) {
			throw new IllegalArgumentException(String.format("lineNumber must be positive: %s", lineNumber));
		}
	}

	public int getLineNumber() {
		return lineNumber;
	}

	public String getMessage() {
		return message;
	}

	@Override
	public String toString() {
		return String.format("line %d: %s", getLineNumber(), getMessage());
	}
}
